#ifndef __LIB_SM2_PHYTIUM_H__
#define __LIB_SM2_PHYTIUM_H__

char *private_key_filename = "test/key/keypair.pem";
char *public_key_filename = "test/key/public.pem";

char *private_key = "-----BEGIN PRIVATE KEY-----\n\
MIGHAgEAMBMGByqGSM49AgEGCCqBHM9VAYItBG0wawIBAQQgg9ygraPXfqTtIIlW\n\
HcOWN16pzlBjKeScDeSZSQrNA3ihRANCAATXTtE+LcmRFHMWOFtnS9VgAaYPA5v8\n\
AYhq61KjQwzcvLwBpB4yzpK5TlBELrFc1CTBI37ELkQskJVqJkZDkxIm\n\
-----END PRIVATE KEY-----\n";

char *public_key = "-----BEGIN PUBLIC KEY-----\n\
MFkwEwYHKoZIzj0CAQYIKoEcz1UBgi0DQgAE107RPi3JkRRzFjhbZ0vVYAGmDwOb\n\
/AGIautSo0MM3Ly8AaQeMs6SuU5QRC6xXNQkwSN+xC5ELJCVaiZGQ5MSJg==\n\
-----END PUBLIC KEY-----\n";

char *sm2_enc_filename[] = {
	"test/sm2enc0.der", "test/sm2enc1.der", "test/sm2enc2.der",
	"test/sm2enc3.der", "test/sm2enc4.der", "test/sm2enc5.der",
	"test/sm2enc6.der", "test/sm2enc7.der",
};

char *sm_raw_filename[] = {
	"test/smraw0.txt", "test/smraw1.txt", "test/smraw2.txt",
	"test/smraw3.txt", "test/smraw4.txt", "test/smraw5.txt",
	"test/smraw6.txt", "test/smraw7.txt",
};

char *sm2_sign_filename[] = {
	"test/sm2sign0.der", "test/sm2sign1.der", "test/sm2sign2.der",
	"test/sm2sign3.der", "test/sm2sign4.der", "test/sm2sign5.der",
	"test/sm2sign6.der", "test/sm2sign7.der",
};

struct sm2_info {
	uint32_t type;
	uint32_t src_len;
	uint32_t dst_len;
	uint8_t *src;
	uint8_t *dst;
	uint8_t *key;
};

/*API*/
int phytium_scto_sm2_sign(uint8_t *e, const uint32_t e_len, uint8_t *priv_key,
			  const uint32_t priv_key_len, uint8_t *der_code_out,
			  uint32_t *der_code_out_len);
int phytium_scto_sm2_verify(uint8_t *e, const uint32_t e_len, uint8_t *pub_key,
			    const uint32_t pub_key_len, uint8_t *sign_result,
			    uint32_t sign_result_len);
int phytium_scto_sm2_dec(uint8_t *src, const uint32_t src_len,
			 uint8_t *priv_key, const uint32_t priv_key_len,
			 uint8_t *dst, uint32_t *dst_len);
int phytium_scto_sm2_enc(uint8_t *src, const uint32_t src_len, uint8_t *pub_key,
			 const uint32_t pub_key_len, uint8_t *dst,
			 uint32_t *dst_len);

int phytium_scto_sm2_genkey(uint8_t prikey[32], uint8_t pubkey[65]);

int phytium_scto_sm2_exchangekey(uint8_t role, uint8_t *a_prikey,
				 uint8_t *b_pubkey, uint8_t *a_tmp_prikey,
				 uint8_t *a_tmp_pubkey, uint8_t *b_tmp_pubkey,
				 uint8_t *ZA, uint8_t *ZB, uint32_t key_length,
				 uint8_t *key_data, uint8_t *S1, uint8_t *SA);

void scto_sm2signature_encode(uint8_t *input, uint8_t *sig, uint32_t *sig_len);

int scto_sm2signature_decode(uint8_t *sig, uint32_t sig_len, uint8_t *out);

void scto_sm2encrypt_encode(uint8_t *input, uint32_t inlen, uint8_t *output,
			    uint32_t *outlen);

int scto_sm2decrypt_decode(uint8_t *input, uint32_t inlen, uint8_t *output,
			   uint32_t *outlen);
#endif
